## nodejs-mozilla 8.14.0-0ubuntu0.16.04.1

=== debian/changelog ===
nodejs-mozilla (8.14.0-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release: 8.14.0

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 05 Dec 2018 16:16:25 +0100

nodejs-mozilla (8.12.0-0ubuntu0.16.04) UNRELEASED; urgency=medium

  * New package specifically tailored for building firefox >= 64

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Sun, 28 Oct 2018 22:29:15 +0100

## nodejs-mozilla 8.14.0-0ubuntu0.18.04.2

=== debian/changelog ===
nodejs-mozilla (8.14.0-0ubuntu0.18.04.2) bionic; urgency=medium

  * No-change rebuild

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 05 Dec 2018 14:24:06 +0100

nodejs-mozilla (8.14.0-0ubuntu0.18.04.1) bionic; urgency=medium

  * New upstream release: 8.14.0

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 05 Dec 2018 13:12:18 +0100

nodejs-mozilla (8.12.0-0ubuntu0.18.04) UNRELEASED; urgency=medium

  * New package specifically tailored for building firefox >= 64

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Sun, 28 Oct 2018 22:30:08 +0100

## nodejs-mozilla 10.21.0~dfsg

=== deps/openssl/config/Makefile ===
# This Makefile is confirmed to be run only on Linux (CentOS and
# Ubuntu). perl5 and gas(>=2.26) are needed.

UNAME_S := $(shell uname -s)
ifneq ($(UNAME_S),Linux)
  $(error This can be run only on Linux)
endif

PERL    = perl

# Supported architecture list
ASM_ARCHS = aix-gcc aix64-gcc BSD-x86_64 \
darwin64-x86_64-cc darwin-i386-cc linux-aarch64 \
linux-armv4 linux-elf linux-x32 linux-x86_64 linux-ppc \
linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x \
solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32

NO_ASM_ARCHS = VC-WIN64-ARM

CC = gcc
FAKE_GCC = ../config/fake_gcc.pl

CONFIGURE = ./Configure
# no-comp: against CRIME attack
# no-shared: openssl-cli needs static link
# no-afalgeng: old Linux kernel < 4.0 does not support it
COPTS =  no-comp no-shared no-afalgeng

# disable platform check in Configure
NO_WARN_ENV = CONFIGURE_CHECKER_WARN=1

GENERATE = ./generate_gypi.pl

OPSSL_SRC = ../openssl

# Header files generated with Configure
CFG = opensslconf.h
SRC_CFG = $(OPSSL_SRC)/include/openssl/$(CFG)
INT_CFGS = bn_conf.h dso_conf.h
INT_CFG_DIR = $(OPSSL_SRC)/include/crypto

PHONY = all clean replace
.PHONY: $(PHONY)

all: $(ASM_ARCHS) $(NO_ASM_ARCHS) replace

# Configure and generate openssl asm files for each archs
$(ASM_ARCHS):
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(CC) $(PERL) $(CONFIGURE) $(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm $@
# Confgure asm_avx2 and generate upto avx2 support
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(FAKE_GCC) $(PERL) $(CONFIGURE) \
	$(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm_avx2 $@
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@

$(NO_ASM_ARCHS):
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@

# Replace and copy arch dependent headers
replace:
	cp ./$(CFG).tmpl $(SRC_CFG)
	@for c in $(INT_CFGS); do \
	    cp ./$$c.tmpl $(INT_CFG_DIR)/$$c; \
	done

clean:
	find archs \( -name \*.S -o -name \*.s -o -name \*.asm -o \
	-name \*.gypi -o -name \*.h -o -name \*.pm -o -name \*.rc \) -exec rm "{}" \;

=== debian/changelog ===
nodejs-mozilla (10.21.0~dfsg-1~deb9u1) stretch-security; urgency=medium

  * Non-maintainer upload.
  * Update nodejs-mozilla to 10, required for Firefox/Thunderbird 78.
  * Keep using internal c-ares and libuv as the ones in stretch are
    too old.
    + Disable uv_stable.patch to avoid a test failure with the internal
      libuv.
  * Also use internal brotli, new requirement in node v10 not available
    in stretch. Add it in a patch as it was removed in the dfsg tarball
    (due to lack of usage) to avoid repacking it again.
  * Embed acorn 5.5.3.
  * Lower openssl requirement to 1.1.0.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Wed, 23 Sep 2020 22:03:33 +0200

nodejs (10.21.0~dfsg-1~deb10u1) buster-security; urgency=medium

  * New upstream version 10.21.0~dfsg. Closes: #962145.
  * Security fixes:
    + CVE-2020-11080
    + CVE-2020-8172
    + CVE-2020-8174

 -- Jérémy Lal <kapouer@melix.org>  Thu, 04 Jun 2020 02:35:16 +0200

nodejs (10.19.0~dfsg1-1) buster-security; urgency=medium

  * New upstream version 10.19.0~dfsg1
  * Delete applied ssl 1.1.1 compatibility patches
  * Revert upstream changes to stay compatible with stable libuv1:
    + uv_os_uname is not available
    + test-dgram-address uv returns EINVAL, not EBADF
  * Never run tests in parallel to avoid memory exhaustion
  * Use embedded nghttp2 as upstream rely that much on having
    an updated version of it.
  * Avoid two tests to cause a FTBFS (Closes #919588)
  * Patch for compatibility with libuv1 from stable
  * uv in stable expects EINVAL, not EBADF
  * Link to atomic using a patch, LDFLAGS is not enough
  * Exclude brotli from deps, use system-installed one
    + B-D brotli
    + use upstream patch

 -- Jérémy Lal <kapouer@melix.org>  Mon, 20 Apr 2020 09:44:09 +0200

nodejs (10.15.2~dfsg-2) unstable; urgency=medium

  * Avoid two tests to cause a FTBFS (Closes #919588)
    + test-fs-error-messages fails with eatmydata
    + test-net-listen-after-destroying-stdin is flaky
  * gbp for debian/buster branch

 -- Jérémy Lal <kapouer@melix.org>  Mon, 08 Apr 2019 15:06:40 +0200

nodejs (10.15.2~dfsg-1) unstable; urgency=high

  * New upstream version 10.15.2~dfsg
    Slowloris HTTP Denial of Service with keep-alive
    (CVE-2019-5737)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 28 Feb 2019 15:52:30 +0100

nodejs (10.15.1~dfsg-5) unstable; urgency=medium

  * Install only headers
  * /usr/include/v8 should contain the headers directly

 -- Jérémy Lal <kapouer@melix.org>  Sat, 09 Feb 2019 11:55:56 +0100

nodejs (10.15.1~dfsg-4) experimental; urgency=medium

  * Add libv8-dev symlinks:
    + libv8_libbase.so
    + libv8_libplatform.so
    + libv8_libsampler.so

 -- Jérémy Lal <kapouer@melix.org>  Fri, 08 Feb 2019 16:13:57 +0100

nodejs (10.15.1~dfsg-3) experimental; urgency=medium

  * Provides libv8-dev (Closes: #920329)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 08 Feb 2019 14:25:03 +0100

nodejs (10.15.1~dfsg-2) unstable; urgency=medium

  * Fix Build-Deps and add libssl-dev to libnode-dev.
    Closes: #921074.
  * Refactor deps in debian/rules
  * Declare Breaks properly in rules/control.in.in

 -- Jérémy Lal <kapouer@melix.org>  Fri, 01 Feb 2019 22:18:18 +0100

nodejs (10.15.1~dfsg-1) experimental; urgency=medium

  * New upstream version 10.15.1~dfsg
  * Backport upstream-approved Node 11 openssl 1.1.1a support
    (except a test that was weird to backport).

  [ Mattia Rizzolo ]
  * Add Breaks:node-modern-syslog (<< 1.1.4-2) to libnode64.
    node-modern-syslog before 1.1.4-2 depended on the nodejs
    ABI, but didn't have an appropriate dependency.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 31 Jan 2019 09:54:11 +0100

nodejs (10.15.0~dfsg-10) unstable; urgency=medium

  * M-A: same on libnode-dev, nodejs-dev
  * Drop nodejs-dev package.
    Addons should instead:
    + Build-Depends libnode-dev, node-gyp
    + remove dh --with nodejs argument in debian/rules
    + use debhelper >= 10 because it strips and shlibs *.node files

 -- Jérémy Lal <kapouer@melix.org>  Fri, 25 Jan 2019 13:51:37 +0100

nodejs (10.15.0~dfsg-9) unstable; urgency=medium

  * M-A: foreign on nodejs-doc
  * libnode-dev depends libuv1-dev (Closes: #905415)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 21 Jan 2019 08:33:36 +0100

nodejs (10.15.0~dfsg-8) unstable; urgency=medium

  * Suggests npm - because nodejs must not be blocked by it.
    Closes: #918388.
  * Patch to silence buffer deprecations. Closes: #918456.
    This patch is meant to ease migration to testing, and to be
    removed as soon as possible.
    It avoids printing to stderr deprecation warning about
    calling Buffer as a constructor without the new operator.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 06 Jan 2019 11:18:34 +0100

nodejs (10.15.0~dfsg-7) unstable; urgency=medium

  * Add missing shlibs, Closes: #917961.
  * Nodejs 10 is here, Close #914965.
  * libnode-dev: install openssl.cnf in /usr/include/nodejs
  * Recommends npm, Closes: #918388.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 05 Jan 2019 19:48:20 +0100

nodejs (10.15.0~dfsg-6) unstable; urgency=medium

  * nodejs: strict dependency on libnode64

 -- Jérémy Lal <kapouer@melix.org>  Tue, 01 Jan 2019 19:03:27 +0100

nodejs (10.15.0~dfsg-5) experimental; urgency=medium

  * mips(el): -latomic
  * Remove split-dwarf for any arch, only for mips
  * Forgot to export LDFLAGS

 -- Jérémy Lal <kapouer@melix.org>  Sat, 29 Dec 2018 17:16:30 +0100

nodejs (10.15.0~dfsg-4) experimental; urgency=medium

  * CPPFLAGS, CFLAGS -gsplit-dwarf for any arch
    Why would this be reserved to mips anyway.
  * Standards-Version 4.3.0

 -- Jérémy Lal <kapouer@melix.org>  Fri, 28 Dec 2018 11:19:02 +0100

nodejs (10.15.0~dfsg-3) experimental; urgency=medium

  * Add CPPFLAGS += -gsplit-dwarf as well

 -- Jérémy Lal <kapouer@melix.org>  Fri, 28 Dec 2018 10:04:23 +0100

nodejs (10.15.0~dfsg-2) experimental; urgency=medium

  * Add -gsplit-dwarf on mips to work around #829139



=== debian/control ===
Source: nodejs-mozilla
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 debhelper (>=9.20160114),
 dh-buildinfo,
 pkg-config,
 bash-completion,
 libkvm-dev [kfreebsd-any],
 gyp (>= 0.1~svn1773),
 openssl (>= 1.1.0~),
 zlib1g-dev,
 libicu-dev,
# libc-ares-dev (>= 1.14~),
# libbrotli-dev,
 curl,
 procps,
# node-acorn,
 ca-certificates,
 python,
 libssl-dev (>= 1.1.0~),
# libuv1-dev (>= 1.20.0~)
Standards-Version: 4.3.0
Homepage: http://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-10.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-10.x

Package: nodejs-mozilla
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends},
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# This needs to run before inclusion of CDBS snippets
debian/control:: debian/control.in debian/watch
DEB_PHONY_RULES += debian/control.in debian/watch
debian/control.in::
	sed $(foreach re,ABI ARCHS BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/control.in.in > debian/control.in

debian/watch::
	sed $(foreach re,BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/watch.in > debian/watch

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20160114)

# Do not install licensecheck please
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Needed by upstream build
#  * recent gyp needed to build using flock
bdeps = pkg-config, bash-completion, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
bdeps +=, openssl (>= 1.1.0~)
bdeps +=, zlib1g-dev
bdeps +=, libicu-dev
# bdeps +=, libc-ares-dev (>= 1.14~)
# bdeps +=, libnghttp2-dev (>= 1.34.0~)
# bdeps +=, libhttp-parser-dev (>= 2.8~)
# bdeps +=, libbrotli-dev

# Needed by dev
devdeps = libssl-dev (>= 1.1.0~)
devdeps +=, libuv1-dev (>= 1.20.0~)

# Needed for tests
bdeps +=, curl, procps,
# bdeps +=, node-acorn
bdeps +=, ca-certificates
bdeps +=, python

CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps), $(devdeps)
CDBS_DEPENDS_libnode-dev = $(devdeps)

CDBS_RECOMMENDS_nodejs = ca-certificates
CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev, libv8-dev
CDBS_PROVIDES_libnode-dev = libv8-dev
CDBS_CONFLICTS_libnode-dev = libv8-dev (<= 3.14.5.8-11)
LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--without-npm \
--without-snapshot \
--shared \
--shared-zlib \
--with-intl=system-icu \
--prefix=/usr/lib/nodejs-mozilla \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs"

DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl

# map HOST ARCH AND OS, and if unknown let upstream guess

# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

#DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
# avoid troubles, never run tests with multiple jobs
export JOBS = 1
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

DEB_DH_MAKESHLIBS_ARGS_ALL = -X/usr/lib/nodejs-mozilla/bin/lib.target

# build -fPIC
CFLAGS+=-fPIC
CPPFLAGS+=-fPIC
# hardening gyp
CFLAGS+=-g
CPPFLAGS+=-g
CXXFLAGS+=$(CPPFLAGS)
export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

# properly clean files from build, test, python
clean::
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	rm -f node_modules
	rm -rf tools/node_modules
	find . -name "*.pyc" -delete
	rm -rf out
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links

binary-post-install/nodejs-mozilla::
	mv debian/nodejs-mozilla/usr/lib/nodejs-mozilla/lib debian/nodejs-mozilla/usr/lib/nodejs-mozilla/bin/lib.target

pre-build::
	ln -sTf /usr/lib/nodejs node_modules
	mkdir -p $(NODE_TEST_DIR)

check:
	-ln -s /usr/bin/node node
	mkdir -p $(NODE_TEST_DIR)

## nodejs-mozilla 12.16.1

=== debian/changelog ===
nodejs-mozilla (12.16.1-0ubuntu0.18.04.2) bionic; urgency=medium

  * New upstream release: 12.16.1

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Thu, 02 Apr 2020 15:14:42 +0200

## nodejs-mozilla 12.18.1

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')
COVTESTS ?= test-cov
COV_SKIP_TESTS ?= core_line_numbers.js,testFinalizer.js,test_function/test.js
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)
BUILD_WITH ?= make

ifdef JOBS
	PARALLEL_ARGS = -j $(JOBS)
else
	PARALLEL_ARGS = -J
endif

ifdef ENABLE_V8_TAP
	TAP_V8 := --junitout $(PWD)/v8-tap.xml
	TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
	TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
	V8_BUILD_OPTIONS += i18nsupport=off
endif

ifeq ($(OSTYPE), darwin)
	GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[A-Z]' '[a-z]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=small-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to quiet/pretty builds.
# To do verbose builds, run `make V=1` or set the V environment variable.
V ?= 0

# Use -e to double check in case it's a broken link
# Use $(PWD) so we can cd to anywhere before calling this
available-node = \
	if [ -x $(PWD)/$(NODE) ] && [ -e $(PWD)/$(NODE) ]; then \
		$(PWD)/$(NODE) $(1); \
	elif [ -x `which node` ] && [ -e `which node` ] && [ `which node` ]; then \
		`which node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[a-zA-Z0-9._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
ifeq ($(BUILD_WITH), make)
$(NODE_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Release V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
ifeq ($(BUILD_WITH), ninja)
ifeq ($(V),1)
	NINJA_ARGS := $(NINJA_ARGS) -v
endif
ifdef JOBS
	NINJA_ARGS := $(NINJA_ARGS) -j$(JOBS)
else
	NINJA_ARGS := $(NINJA_ARGS) $(filter -j%,$(MAKEFLAGS))
endif
$(NODE_EXE): config.gypi out/Release/build.ninja
	ninja -C out/Release $(NINJA_ARGS)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Debug/build.ninja
	ninja -C out/Debug $(NINJA_ARGS)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
$(NODE_EXE) $(NODE_G_EXE):
	echo This Makefile currently only supports building with 'make' or 'ninja'
endif
endif


ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif

.PHONY: with-code-cache
with-code-cache:
	echo "'with-code-cache' target is a noop"

.PHONY: test-code-cache
test-code-cache: with-code-cache
	echo "'test-code-cache' target is a noop"

out/Makefile: config.gypi common.gypi node.gyp \
	deps/uv/uv.gyp deps/http_parser/http_parser.gyp deps/zlib/zlib.gyp \
	tools/v8_gypfiles/toolchain.gypi tools/v8_gypfiles/features.gypi \
	tools/v8_gypfiles/inspector.gypi tools/v8_gypfiles/v8.gyp
	$(PYTHON) tools/gyp_node.py -f make

# node_version.h is listed because the N-API version is taken from there
# and included in config.gypi
config.gypi: configure configure.py src/node_version.h
	@if [ -x config.status ]; then \
		./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	$(MAKE) testclean
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: testclean
testclean:
# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*

.PHONY: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi config_fips.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	$(RM) -r node_modules
	$(RM) -r gcovr build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/test/cctest/*.gcno

.PHONY: coverage
# Build and test with code coverage reporting.  Leave the lib directory
# instrumented for any additional runs the user may want to make.
# For C++ coverage reporting, this needs to be run in conjunction with configure
#  --coverage.  html coverage reports will be created under coverage/
# Related CI job: node-test-commit-linux-coverage
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	-$(MAKE) coverage-build-js
	if [ ! -d gcovr ]; then git clone -b 3.4 --depth=1 \
		--single-branch https://github.com/gcovr/gcovr.git; fi
	if [ ! -d build ]; then git clone --depth=1 \
		--single-branch https://github.com/nodejs/build.git; fi
	if [ ! -f gcovr/scripts/gcovr.orig ]; then \
		(cd gcovr && patch -N -p1 < \
		"$(CURDIR)/build/jenkins/scripts/coverage/gcovr-patches-3.4.diff"); fi
	$(MAKE)

.PHONY: coverage-build-js
coverage-build-js:
	mkdir -p node_modules
	if [ ! -d node_modules/c8 ]; then \
		$(NODE) ./deps/npm install c8 --no-save --no-package-lock;\
	fi

.PHONY: coverage-test
coverage-test: coverage-build
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/*/*.gcda
	-NODE_V8_COVERAGE=out/$(BUILDTYPE)/.coverage \
								TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) $(COVTESTS)
	$(MAKE) coverage-report-js
	-(cd out && "../gcovr/scripts/gcovr" \
		--gcov-exclude='.*\b(deps|usr|out|cctest)\b' -v -r Release/obj.target \
		--html --html-detail -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	@echo -n "Javascript coverage %: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@echo -n "C++ coverage %: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

COV_REPORT_OPTIONS = --reporter=html \
	--temp-directory=out/$(BUILDTYPE)/.coverage --omit-relative=false \
	--resolve=./lib --exclude="benchmark/" --exclude="deps/" --exclude="test/" --exclude="tools/" \
	--wrapper-length=0
ifdef COV_ENFORCE_THRESHOLD
	COV_REPORT_OPTIONS += --check-coverage --lines=$(COV_ENFORCE_THRESHOLD)
endif

.PHONY: coverage-report-js
coverage-report-js:
	$(NODE) ./node_modules/.bin/c8 report $(COV_REPORT_OPTIONS)

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-js-native-api-tests build-node-api-tests ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(CI_JS_SUITES) \
		$(CI_NATIVE_SUITES)

.PHONY: tooltest
tooltest:
	@$(PYTHON) -m unittest discover -s ./test/tools

.PHONY: coverage-run-js
coverage-run-js:
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(MAKE) coverage-build-js
	-NODE_V8_COVERAGE=out/$(BUILDTYPE)/.coverage CI_SKIP_TESTS=$(COV_SKIP_TESTS) \
					TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) jstest
	$(MAKE) coverage-report-js

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s tooltest
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-js-native-api-tests
	$(MAKE) -s build-node-api-tests
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	$(MAKE) jstest
	$(MAKE) tooltest

# Used by `make coverage-test`
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	CI_SKIP_TESTS=$(COV_SKIP_TESTS) $(MAKE) jstest

test-parallel: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) parallel

test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.js doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

node_use_openssl = $(call available-node,"-p" \
			 "process.versions.openssl != undefined")
test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules
	@if [ "$(shell $(node_use_openssl))" != "true" ]; then \
		echo "Skipping .docbuildstamp (no crypto)"; \
	else \
		$(RM) -r test/addons/??_*/; \
		[ -x $(NODE) ] && $(NODE) $< || node $< ; \
		touch $@; \
	fi

ADDONS_BINDING_GYPS := \
	$(filter-out test/addons/??_*/binding.gyp, \
		$(wildcard test/addons/*/binding.gyp))

ADDONS_BINDING_SOURCES := \
	$(filter-out test/addons/??_*/*.cc, $(wildcard test/addons/*/*.cc)) \

=== deps/http_parser/Makefile ===
# Copyright Joyent, Inc. and other Node contributors. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

PLATFORM ?= $(shell sh -c 'uname -s | tr "[A-Z]" "[a-z]"')
HELPER ?=
BINEXT ?=
SOLIBNAME = libhttp_parser
SOMAJOR = 2
SOMINOR = 9
SOREV   = 3
ifeq (darwin,$(PLATFORM))
SOEXT ?= dylib
SONAME ?= $(SOLIBNAME).$(SOMAJOR).$(SOMINOR).$(SOEXT)
LIBNAME ?= $(SOLIBNAME).$(SOMAJOR).$(SOMINOR).$(SOREV).$(SOEXT)
else ifeq (wine,$(PLATFORM))
CC = winegcc
BINEXT = .exe.so
HELPER = wine
else
SOEXT ?= so
SONAME ?= $(SOLIBNAME).$(SOEXT).$(SOMAJOR).$(SOMINOR)
LIBNAME ?= $(SOLIBNAME).$(SOEXT).$(SOMAJOR).$(SOMINOR).$(SOREV)
endif

CC?=gcc
AR?=ar

CPPFLAGS ?=
LDFLAGS ?=

CPPFLAGS += -I.
CPPFLAGS_DEBUG = $(CPPFLAGS) -DHTTP_PARSER_STRICT=1
CPPFLAGS_DEBUG += $(CPPFLAGS_DEBUG_EXTRA)
CPPFLAGS_FAST = $(CPPFLAGS) -DHTTP_PARSER_STRICT=0
CPPFLAGS_FAST += $(CPPFLAGS_FAST_EXTRA)
CPPFLAGS_BENCH = $(CPPFLAGS_FAST)

CFLAGS += -Wall -Wextra -Werror
CFLAGS_DEBUG = $(CFLAGS) -O0 -g $(CFLAGS_DEBUG_EXTRA)
CFLAGS_FAST = $(CFLAGS) -O3 $(CFLAGS_FAST_EXTRA)
CFLAGS_BENCH = $(CFLAGS_FAST) -Wno-unused-parameter
CFLAGS_LIB = $(CFLAGS_FAST) -fPIC

LDFLAGS_LIB = $(LDFLAGS) -shared

INSTALL ?= install
PREFIX ?= /usr/local
LIBDIR = $(PREFIX)/lib
INCLUDEDIR = $(PREFIX)/include

ifeq (darwin,$(PLATFORM))
LDFLAGS_LIB += -Wl,-install_name,$(LIBDIR)/$(SONAME)
else
# TODO(bnoordhuis) The native SunOS linker expects -h rather than -soname...
LDFLAGS_LIB += -Wl,-soname=$(SONAME)
endif

test: test_g test_fast
	$(HELPER) ./test_g$(BINEXT)
	$(HELPER) ./test_fast$(BINEXT)

test_g: http_parser_g.o test_g.o
	$(CC) $(CFLAGS_DEBUG) $(LDFLAGS) http_parser_g.o test_g.o -o $@

test_g.o: test.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_DEBUG) $(CFLAGS_DEBUG) -c test.c -o $@

http_parser_g.o: http_parser.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_DEBUG) $(CFLAGS_DEBUG) -c http_parser.c -o $@

test_fast: http_parser.o test.o http_parser.h
	$(CC) $(CFLAGS_FAST) $(LDFLAGS) http_parser.o test.o -o $@

test.o: test.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_FAST) $(CFLAGS_FAST) -c test.c -o $@

bench: http_parser.o bench.o
	$(CC) $(CFLAGS_BENCH) $(LDFLAGS) http_parser.o bench.o -o $@

bench.o: bench.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_BENCH) $(CFLAGS_BENCH) -c bench.c -o $@

http_parser.o: http_parser.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_FAST) $(CFLAGS_FAST) -c http_parser.c

test-run-timed: test_fast
	while(true) do time $(HELPER) ./test_fast$(BINEXT) > /dev/null; done

test-valgrind: test_g
	valgrind ./test_g

libhttp_parser.o: http_parser.c http_parser.h Makefile
	$(CC) $(CPPFLAGS_FAST) $(CFLAGS_LIB) -c http_parser.c -o libhttp_parser.o

library: libhttp_parser.o
	$(CC) $(LDFLAGS_LIB) -o $(LIBNAME) $<

package: http_parser.o
	$(AR) rcs libhttp_parser.a http_parser.o

url_parser: http_parser.o contrib/url_parser.c
	$(CC) $(CPPFLAGS_FAST) $(CFLAGS_FAST) $^ -o $@

url_parser_g: http_parser_g.o contrib/url_parser.c
	$(CC) $(CPPFLAGS_DEBUG) $(CFLAGS_DEBUG) $^ -o $@

parsertrace: http_parser.o contrib/parsertrace.c
	$(CC) $(CPPFLAGS_FAST) $(CFLAGS_FAST) $^ -o parsertrace$(BINEXT)

parsertrace_g: http_parser_g.o contrib/parsertrace.c
	$(CC) $(CPPFLAGS_DEBUG) $(CFLAGS_DEBUG) $^ -o parsertrace_g$(BINEXT)

tags: http_parser.c http_parser.h test.c
	ctags $^

install: library
	$(INSTALL) -D  http_parser.h $(DESTDIR)$(INCLUDEDIR)/http_parser.h
	$(INSTALL) -D $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(LIBNAME)
	ln -sf $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(SONAME)
	ln -sf $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(SOLIBNAME).$(SOEXT)

install-strip: library
	$(INSTALL) -D  http_parser.h $(DESTDIR)$(INCLUDEDIR)/http_parser.h
	$(INSTALL) -D -s $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(LIBNAME)
	ln -sf $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(SONAME)
	ln -sf $(LIBNAME) $(DESTDIR)$(LIBDIR)/$(SOLIBNAME).$(SOEXT)

uninstall:
	rm $(DESTDIR)$(INCLUDEDIR)/http_parser.h
	rm $(DESTDIR)$(LIBDIR)/$(SOLIBNAME).$(SOEXT)
	rm $(DESTDIR)$(LIBDIR)/$(SONAME)
	rm $(DESTDIR)$(LIBDIR)/$(LIBNAME)

clean:
	rm -f *.o *.a tags test test_fast test_g \
		http_parser.tar libhttp_parser.so.* \
		url_parser url_parser_g parsertrace parsertrace_g \
		*.exe *.exe.so

contrib/url_parser.c:	http_parser.h
contrib/parsertrace.c:	http_parser.h

.PHONY: clean package test-run test-run-timed test-valgrind install install-strip uninstall

=== deps/openssl/config/Makefile ===
--- 
+++ 
@@ -9,10 +9,10 @@
 PERL    = perl
 
 # Supported architecture list
-ASM_ARCHS = aix-gcc aix64-gcc BSD-x86_64 \
+ASM_ARCHS = aix-gcc aix64-gcc BSD-x86 BSD-x86_64 \
 darwin64-x86_64-cc darwin-i386-cc linux-aarch64 \
 linux-armv4 linux-elf linux-x32 linux-x86_64 linux-ppc \
-linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x \
+linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x linux64-mips64\
 solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32
 
 NO_ASM_ARCHS = VC-WIN64-ARM
@@ -24,7 +24,8 @@
 # no-comp: against CRIME attack
 # no-shared: openssl-cli needs static link
 # no-afalgeng: old Linux kernel < 4.0 does not support it
-COPTS =  no-comp no-shared no-afalgeng
+# enable-ssl-trace: cause the optional SSL_trace API to be built
+COPTS =  no-comp no-shared no-afalgeng enable-ssl-trace
 
 # disable platform check in Configure
 NO_WARN_ENV = CONFIGURE_CHECKER_WARN=1

=== debian/changelog ===
nodejs-mozilla (12.18.1-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release: 12.18.1

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Thu, 25 Jun 2020 18:21:03 +0200

nodejs-mozilla (12.16.1-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release: 12.16.1

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 01 Apr 2020 15:01:53 +0200

=== debian/control ===
Source: nodejs-mozilla
Section: javascript
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper, python
Standards-Version: 4.1.2
Homepage: http://nodejs.org/
Vcs-Browser: https://code.launchpad.net/~mozillateam/+git/nodejs-mozilla
Vcs-Git: https://git.launchpad.net/~mozillateam/+git/nodejs-mozilla

Package: nodejs-mozilla
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: evented I/O for V8 javascript
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CONFIGURE_FLAGS = --prefix=/usr/lib/nodejs-mozilla --without-npm
ifeq (armhf, $(DEB_HOST_ARCH))
CONFIGURE_FLAGS += --with-arm-float-abi=hard
endif

export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp

%:
	dh $@ --parallel

override_dh_auto_configure:
	./configure ${CONFIGURE_FLAGS}

override_dh_auto_test:
ifeq (armhf, $(DEB_HOST_ARCH))
	# All tests appear to pass on armhf, yet the exit code isn't 0.
	# This would require further investigation.
	make test-ci-js || true
else
	make test-ci-js
endif

## nodejs-mozilla 12.22.12

=== deps/openssl/config/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 # Supported architecture list
 ASM_ARCHS = aix-gcc aix64-gcc BSD-x86 BSD-x86_64 \
-darwin64-x86_64-cc darwin-i386-cc linux-aarch64 \
+darwin64-x86_64-cc darwin-i386-cc darwin64-arm64-cc linux-aarch64 \
 linux-armv4 linux-elf linux-x32 linux-x86_64 linux-ppc \
 linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x linux64-mips64\
 solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32

=== debian/changelog ===
nodejs-mozilla (12.22.12-0ubuntu0.18.04.2) bionic; urgency=medium

  * Do not make parallel builds conditional on the architecture,
    for consistency with the focal branch (where the packages FTBFS
    on Launchpad when using parallelization on all architectures)
    - debian/rules

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 27 Jul 2022 18:16:08 +0200

nodejs-mozilla (12.22.12-0ubuntu0.18.04.1) bionic; urgency=medium

  * New upstream release: 12.22.12 (now required to build Firefox 104,
    see https://bugzilla.mozilla.org/show_bug.cgi?id=1762571)

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Fri, 22 Jul 2022 18:58:21 +0200

nodejs-mozilla (12.18.1-0ubuntu0.18.04.1) bionic; urgency=medium

  * New upstream release: 12.18.1

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Thu, 25 Jun 2020 18:29:24 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CONFIGURE_FLAGS = --prefix=/usr/lib/nodejs-mozilla --without-npm
ifeq (armhf, $(DEB_HOST_ARCH))
CONFIGURE_FLAGS += --with-arm-float-abi=hard
CONFIGURE_FLAGS += --with-arm-fpu=vfpv3
endif

export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	./configure $(CONFIGURE_FLAGS)

override_dh_auto_test:
	make test-ci-js

=== debian/watch ===
version=4
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/ \
https://nodejs.org/dist v(12\.\d+\.\d+)/
